Overview | Package | Class | Deprecated | Index | Help
| Groovy Documentation
| FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | PROPERTY | CONSTR | METHOD | DETAIL: FIELD | PROPERTY | CONSTR | METHOD

## org.gradle.plugins.idea
[Groovy] Class IdeaModule

    java.lang.Object
      org.gradle.api.internal.ConventionTask
          org.gradle.api.tasks.GeneratorTask
              org.gradle.api.tasks.XmlGeneratorTask
                  org.gradle.plugins.idea.IdeaModule

    class IdeaModule
    extends XmlGeneratorTask

Generates an IDEA module file.

Authors:
  Hans Dockter

Field Summary

Fields inherited from class GeneratorTask
generator

Property Summary
`boolean` | `downloadJavadoc` Whether to download and add javadoc associated with the dependency jars.
`boolean` | `downloadSources` Whether to download and add sources associated with the dependency jars.
`java.util.Set` | `excludeDirs` The dirs to be excluded by idea.
`java.lang.String` | `javaVersion` If this is null the value of the existing or default ipr XML (inherited) is used.
`java.io.File` | `moduleDir` The content root directory of the module.
`java.io.File` | `outputDir` The idea output dir for the production sources.
`java.util.Map` | `scopes` The keys of this map are the Intellij scopes.
`java.util.Set` | `sourceDirs` The dirs containing the production sources.
`java.io.File` | `testOutputDir` The idea output dir for the test sources.
`java.util.Set` | `testSourceDirs` The dirs containing the test sources.
`java.util.Map` | `variables` The variables to be used for replacing absolute paths in the iml entries.

Method Summary
`protected java.lang.Object` | `addJavadocArtifact(DefaultExternalModuleDependency dependency)`
`protected java.lang.Object` | `addSourceArtifact(DefaultExternalModuleDependency dependency)`
`protected void` | `configure(Module module)`
`protected Module` | `create()`
`protected java.util.Set` | `getAllDeps(java.util.Set deps)`
`protected Path` | `getContentPath()`
`protected java.util.Set` | `getDependencies()`
`protected java.util.Set` | `getExcludePaths()`
`protected java.util.Set` | `getModuleLibraries(java.lang.String scope)`
`protected java.util.Set` | `getModules(java.lang.String scope)`
`protected Path` | `getOutputPath()`
`protected Path` | `getPath(java.io.File file)`
`protected PathFactory` | `getPathFactory()`
`protected java.util.Set` | `getSourcePaths()`
`protected Path` | `getTestOutputPath()`
`protected java.util.Set` | `getTestSourcePaths()`

Methods inherited from class XmlGeneratorTask
configure, create, getXmlTransformer, withXml, withXml

Methods inherited from class GeneratorTask
beforeConfigured, beforeConfigured, getInputFile, getOutputFile, setInputFile, setOutputFile, whenConfigured, whenConfigured

Property Detail

### downloadJavadoc

    @Input
    boolean downloadJavadoc

  Whether to download and add javadoc associated with the dependency jars. Defaults to false.

### downloadSources

    @Input
    boolean downloadSources

  Whether to download and add sources associated with the dependency jars. Defaults to true.

### excludeDirs

    @InputFiles
    java.util.Set excludeDirs

  The dirs to be excluded by idea. Must not be null.

### javaVersion

    @Input
    @Optional
    java.lang.String javaVersion

  If this is null the value of the existing or default ipr XML (inherited) is used. If it is set to `inherited`, the project SDK is used. Otherwise the SDK for the corresponding value of java version is used for this module

### moduleDir

    @InputFiles
    java.io.File moduleDir

  The content root directory of the module. Must not be null.

### outputDir

    @InputFiles
    @Optional
    java.io.File outputDir

  The idea output dir for the production sources. If null no entry for output dirs is created.

### scopes

    java.util.Map scopes

  The keys of this map are the Intellij scopes. Each key points to another map that has two keys, plus and minus. The values of those keys are sets of Configuration objects. The files of the plus configurations are added minus the files from the minus configurations.

### sourceDirs

    @InputFiles
    java.util.Set sourceDirs

  The dirs containing the production sources. Must not be null.

### testOutputDir

    @InputFiles
    @Optional
    java.io.File testOutputDir

  The idea output dir for the test sources. If null no entry for test output dirs is created.

### testSourceDirs

    @InputFiles
    java.util.Set testSourceDirs

  The dirs containing the test sources. Must not be null.

### variables

    java.util.Map variables

  The variables to be used for replacing absolute paths in the iml entries. For example, you might add a GRADLE_USER_HOME variable to point to the Gradle user home dir.

Method Detail

### addJavadocArtifact

    protected java.lang.Object addJavadocArtifact(DefaultExternalModuleDependency dependency)

### addSourceArtifact

    protected java.lang.Object addSourceArtifact(DefaultExternalModuleDependency dependency)

### configure

    @Override
    protected void configure(Module module)

### create

    @Override
    protected Module create()

### getAllDeps

    protected java.util.Set getAllDeps(java.util.Set deps)

### getContentPath

    protected Path getContentPath()

### getDependencies

    protected java.util.Set getDependencies()

### getExcludePaths

    protected java.util.Set getExcludePaths()

### getModuleLibraries

    protected java.util.Set getModuleLibraries(java.lang.String scope)

### getModules

    protected java.util.Set getModules(java.lang.String scope)

### getOutputPath

    protected Path getOutputPath()

### getPath

    protected Path getPath(java.io.File file)

### getPathFactory

    protected PathFactory getPathFactory()

### getSourcePaths

    protected java.util.Set getSourcePaths()

### getTestOutputPath

    protected Path getTestOutputPath()

### getTestSourcePaths

    protected java.util.Set getTestSourcePaths()

Groovy Documentation